function [veck,v_dt,RFM_v] = OGP_Erzeugung(t,v,delta_class_v,Anz_Klassen_dt,delta_class_dt,v_dt,RFM_v, DKI, p_BREMS, Gang)

dt = t(2) - t(1);

 % Neuer Filter Fu 
 %v_bak=v;
 %[a,b]=filterbaun(1.5,100,450,'low',0);
 %v_fu = filtfilt(b,a,v);
 %[b,a] = butter(8,0.1/5);                        % Geschwindigkeit filtern, um nur relevante nderungen zu bercksichtigen 
 %v = filtfilt(b,a,v);

% figure
% plot(v_bak)
% hold on
% plot(v_fu,'r')
% plot(v,'k')



v = smooth(v,100)';                                         %the smoothing function is necessary to obtain usable data

figure                                                      
plot(t,v,'b')      %To print in a graphic the real speed
hold on
plot (t, Gang, 'y')


%% IDENTIFYING THE GEAR SHIFTS 

delta_shift_time=1.5;
tope = find (t==(t(end-1)-delta_shift_time));
base = find (t==delta_shift_time);
gear_shifts=Gang;

for i=base:tope;                                            %We create a new vector that for a short time inteval around the shifting has the value=-2
    if Gang(i)~=Gang(i-1);                                  %The interval width is controlled trough the parameter delta_shift_time
        prev=find(t<=t(i)-delta_shift_time,1,'last');
        next=find(t>=t(i)+delta_shift_time,1,'first');
        gear_shifts(prev:next) = -2; % We set an impossible value to later identify it easily when filtering the gear shifts
    end;
end;

%LAST VALUE CORRECTION                                      %We add an extra point at the end that will be later deleted
v(end+1)=v(end)+50;                                         %this is required because the filtering algorithm needs information 
t(end+1)=(t(end)+(t(end)-t(end-1)));                        %about the next point  and otherwise, the last original point would be skipped                             


%% MAXIMUMS, MINIMUMS AND ZEROS  

%Here we get the local extreme points and put them in the vector maximum_and_minimum
%We also get the transitions to zero and from zero speed. The rest of the zeros are not relevant

points=find(abs(diff(sign(diff(v))))>0)+1; 


%% FINDING THE TREND CHANGE POINTS                               %Now we execute the main filtering algorithm
                                             
filtered_points=1;
candidate=2;           
trend=sign(v(points(2))-v(points(1)));

for i=3:(length(points)-1)
    if sign(v(points(i+1))-v(points(candidate))) ~= trend               %If the trend changes we only update if the difference with the prevus 'candidate' is greater than our sensibility value (delta_class_v)
            if(abs(v(points(i+1))-v(points(candidate)))>delta_class_v)   
                trend = sign(v(points(i+1))-v(points(candidate)));                
                filtered_points=[filtered_points, points(candidate)];
                candidate=i+1;
            end;
    else
        candidate=i+1;                                  %When there's not a change in the tendency we always update the value of the 'candidate' point. That's how we avoid "staircase" graphs  
    end;
end;

%DELETION OF THE LAST VALUE
v(end)=[];                                                      %Now we must delete the last value artificially added by us at the beginning
t(end)=[];

filtered_points=([filtered_points, length(v)]);
plot (t, gear_shifts, 'm') %To print in a graphic the gearshifts


%% BUILDING THE AUXILIARY VECTOR V_M                       %This vector is used to identify aceleration changes by comparing the speed deviations
                                                             %to the average speed deviation for that section
v_m=[];

for i=1:length(filtered_points)-1
    Start=filtered_points(i);
    Last=filtered_points(i+1);
    v_m(Start:Last) = v(Start)+((v(Last)-v(Start))*((t(Start:Last)-t(Start))/(t(Last)-t(Start))));
end;

deviation = v-v_m;


%% SELECTION OF THE IMPORTANT ACELERATION CHANGE POINTS 
 
%OBTAINING ALL THE LOCAL EXTREME POINTS OF THE FUNCTION v - v_m (speed - average evolution of the speed)
change_points=[];            
for i=1:length(filtered_points)-1
    Start=find(points==filtered_points(i)); 
    Last=find(points==filtered_points(i+1));
    change_points=[change_points, points(Start)];
    for k=Start+1:Last-1
        if   abs(((v(points(k+1))-v_m(points(k+1)))- (v(points(k))-v_m(points(k))))-((v(points(k))-v_m(points(k)))- (v(points(k-1))-v_m(points(k-1)))))>0.3
            change_points =[change_points, points(k)];
        end;
    end;
end;
change_points=[change_points, points(Last), filtered_points];
change_points(find(diff(change_points)==0))=[];      


change_points=sort([change_points, points]);              
change_points(find(diff(change_points)==0))=[];     
change_points(end)=[];


%SELECTION OF THE SIGNIFICATIVE POINTS FOR THE ACELERATION CHANGES
save_points=[];   
candidate_max=[];
candidato_min=[];

time_delta=2;
i_1=1;

Start=find(t(change_points)>=0+time_delta, 1, 'first');                                                   
Final=find(t(change_points)<=t(end)-time_delta, 1, 'last');  

for current_time=t(change_points(Start)):(time_delta*0.9):t(change_points(Final));

    i_2=find(t(change_points)>=current_time+time_delta, 1, 'first');
    maximum=max(deviation(change_points(i_1:i_2)));
    position_max=i_1-1+find(deviation(change_points(i_1:i_2))==maximum); 
    
    minimum=min(deviation(change_points(i_1:i_2)));
    position_min=i_1-1+find(deviation(change_points(i_1:i_2))==minimum);
       % a_max=deviation(change_points(candidate_max))
    if deviation(change_points(candidate_max))==maximum;
        save_points=[save_points, candidate_max];
    end;
        %a_min=deviation(change_points(candidato_min))
    if deviation(change_points(candidato_min))==minimum;
        save_points=[save_points, candidato_min];
    end;
    
    candidate_max=position_max;
    candidato_min=position_min;
    
    i_1=find(t(change_points)>=current_time, 1, 'first');
end;
potential_points=sort([change_points(save_points), filtered_points]);
potential_points(find(diff(potential_points)==0))=[];      

% End of the selection, now we start the post-filtering


%% #1 POST FILTER: ELIMINATE THE POINTS CAUSED BY GEAR SHIFTINGS 

delete=[];
pos_0=1;
counter=0;
for i=1:length(potential_points)-1
    pos_1=potential_points(i);
    pos_2=potential_points(i+1);
    if v(pos_2)>v(pos_1) && v(pos_1)>v(pos_0);
      counter=1;  
    end;
    if v(pos_0)>v(pos_1) && v(pos_1)>v(pos_2);
      counter=-1;  
    end;    
    if gear_shifts(pos_1)==-2 && gear_shifts(pos_2)==-2 && v(pos_2)<v(pos_1)
        pos_rec=pos_2+(find (v(pos_2:end)>v(pos_1),1,'first'));
        if ~isempty(pos_rec) 
            if(t(pos_rec)-t(pos_1))<10 && potential_points(i+1)<pos_rec 
                if (v(potential_points(i+1))-v_m(potential_points(i+1))) ~= 0
                    delete=[delete,i+1];
                end;
                if (v(potential_points(i))-v_m(potential_points(i))) ~= 0
                    delete=[delete,i];
                end;
             end;
         end;        
    elseif gear_shifts(pos_1)==-2 && counter~=0 && v(pos_1)~=0
        delete=[delete, i];
    end;
    pos_0 = pos_1;  
    counter=0;
end;
potential_points(delete)=[];


%% #2 POST FILTER: ELIMINATE POINTS WITH NO SIGNIFICATIVE ACCELERATION CHANGE 
 
i=2;
while i <length(potential_points)-1   %With this filter we delete the points with small aceleration change
    if (sign(v(potential_points(i))-v(potential_points(i-1)))==sign(v(potential_points(i+1))-v(potential_points(i))))
        a=((v(potential_points(i+1))-v(potential_points(i)))/(t(potential_points(i+1))-t(potential_points(i))));
        b= ((v(potential_points(i))-v(potential_points(i-1)))/(t(potential_points(i))-t(potential_points(i-1))));
        if abs(a-b)<0.75
            potential_points(i)=[];
            i=i-1;
        end;
    end;
    i=i+1;
end;


%% #3 POST FILTER: SMALL GAPS 

likeli=0;
for i=2:length(potential_points)-1
    %Constant scalar
    factor_a=2;
    %Too much time with the previous one
    factor_b=abs(t(potential_points(i))-t(potential_points(i-1)));
    %Sharp speed profile ahead
    factor_c=abs(abs(v(potential_points(i+1))-v(potential_points(i)))/(t(potential_points(i+1))-t(potential_points(i))));
    %Strong speed variation
    factor_d=abs(abs(v(potential_points(i+1))-v(potential_points(i)))/(t(potential_points(i+1))-t(potential_points(i))) - (abs(v(potential_points(i))-v(potential_points(i-1)))/(t(potential_points(i))-t(potential_points(i-1)))));
    %Big gap with the following speed
    factor_e=abs(v(potential_points(i+1))-v(potential_points(i)));
    
    if deviation(potential_points(i))==0
        factor_f=4;
    else
        factor_f=1;
    end;
    
    total= factor_c * factor_d * factor_e * factor_f;
    likeli=[likeli, total];
end;
likeli=[likeli, 0];
length(potential_points);
length(likeli);

likeli(1:end)=((likeli(1:end)*100)/max(likeli));


% Now we build the selector
i=4;
while i<length(potential_points)
    cont_1=0;
    cont_2=0;
    maximum=max( v( potential_points(i-3): potential_points(i-1) ) );
    minimum=min( v( potential_points(i-3): potential_points(i-1) ) );
    if (( (v(potential_points(i-3))+delta_class_v) >=maximum) || ( (v(potential_points(i-1))+delta_class_v) >=maximum))&&(( (v(potential_points(i-3))-delta_class_v)<=minimum) || ( (v(potential_points(i-1))-delta_class_v) <=minimum))
        cont_2=1; %The point i-2 can be deleted
    end;
    maximum=max( v( potential_points(i-2): potential_points(i) ) );
    minimum=min( v( potential_points(i-2): potential_points(i) ) );
    if (( (v(potential_points(i-2))+delta_class_v) >=maximum) || ( (v(potential_points(i))+delta_class_v) >=maximum))&&(( (v(potential_points(i-2))-delta_class_v)<=minimum) || ( (v(potential_points(i))-delta_class_v) <=minimum))
        cont_1=1; %The point i-1 can be deleted
    end;
    
    
    if abs(v(potential_points(i-1))-v(potential_points(i-2)))<delta_class_v
            if cont_1==1
                if cont_2==1
                    if likeli(i-2)>likeli(i-1)
                        potential_points(i-1)=[];
                        likeli(i-1)=[];
                        %disp ('delete 2')
                        i=i-1;
                    else
                        potential_points(i-2)=[];
                        likeli(i-2)=[];
                        %disp ('delete 1')
                        i=i-1;
                    end;
                else
                    potential_points(i-1)=[];
                    likeli(i-1)=[];
                    %disp ('delete 2')
                    i=i-1;   
                end;
            elseif cont_2==1
                potential_points(i-2)=[];
                likeli(i-2)=[];
                %disp ('delete 1')
                i=i-1;    
            end;
    end;
    i=i+1;
end;


%% CREATION OF VECTOR VECK FROM THE FILTERED POINTS    

Ind=potential_points; % Renaming the points
Ind(1)=[];
Ind(end)=[];


for i = 1 : length(Ind)-1                                       %Now the veck vector is created using the filtered points in Ind                          
    veck(Ind(i):Ind(i+1)) = v(Ind(i+1));                        %It contains the next target speed for each point in Ind
end

veck(Ind(end) : length(t)) = v(end);              % und endet bei der letzten gemessenen Geschwindigkeit
    
% veck(Ind(end)) = 0;                             % am Schluss wird angehalten
% veck(t(end)) = 0;                               % am Schluss wird angehalten (Fu)

%%% OGP Statistik basteln

% load str_11.asc
% s = cumtrapz(t,v./3.6);
% for ii=1:length(ogp_11)
%     ind=find(s<=str11_neu(ii,1));
%     v_eck_neu(ind)=str11_neu(ii,2);
% end

for i = 1 : length(Ind)                                                 % Schleife ber den OG-Sprngen 
    
    if i > 1
        class_veck_start = ceil(veck(Ind(i-1)) / delta_class_v);        % Startklasse bestimmen
    else
        class_veck_start = 0;                                           % Beim ersten OG-Sprung ist die Startgeschwindigkeit null  est la velocidad de salto 0
    end
    if class_veck_start == 0; class_veck_start = 1; end                 % Anfahren -> 1. Klasse 
    if class_veck_start == 2; class_veck_start = 1; end                 % die erste Geschwindigkeitsklasse soll nicht besetzt sein (da gibt es Probleme mit dem v-Regler) 
        
    class_veck_ziel  = ceil(veck(Ind(i)) / delta_class_v);              % Zielklasse bestimmen 
    if class_veck_ziel == 0; class_veck_ziel = 1; end                   % Anhalten -> 1. Klasse 
    if class_veck_ziel == 2; class_veck_ziel = 1; end                   % die erste Geschwindigkeitsklasse soll nicht besetzt sein (da gibt es Probleme mit dem v-Regler) 
    
    if i < length(Ind)
        delta_t = (Ind(i+1) - Ind(i)) * dt;                             % Zeit zwischen den OG-Sprngen berechnen 
    else                                                                % wenn der letzte OG-Sprung dran ist 
        delta_t = (length(t) - Ind(i)) * dt;                            % dann Zeit bis zum Ende des Messschriebs nehmen 
    end
    
    class_dt = ceil(delta_t / delta_class_dt);                          % Ermittlung der dt-Klasse 
    if class_dt > Anz_Klassen_dt; class_dt = Anz_Klassen_dt; end        % wenn Haltedauer lnger als max-Klassenzahl, dann in die letzte Klasse schreiben
    if class_dt < 1; continue; end                                      % wenn Haltedauer = 0, dann Sprung ignorieren 
   
    if class_veck_ziel == class_veck_start; continue; end               % Wenn Start-und Zielklasse identisch sind, dann ignorieren 
    
    RFM_v(class_veck_start,class_veck_ziel) = RFM_v(class_veck_start,class_veck_ziel) + 1;      % Hufigkeit in die Statistik eintragen 
    v_dt(class_dt,class_veck_start,class_veck_ziel) = v_dt(class_dt,class_veck_start,class_veck_ziel) + 1; % Hufigkeit in die Statistik eintragen = 
%     disp([ num2str(class_dt) '     ' num2str(class_veck_start) '     ' num2str(class_veck_ziel) ])
end


if 1            % Kontrollplot

plot(t,veck,'r')
    
%figure
%plot(t,v,'b')                                      
%hold on
%plot (t, DKI, 'g')
%plot (t, Gang, 'y')
%plot (t, gear_shifts, 'm')

end



if 0            % Kontrollplot
figure
surf(RFM_v)
view(2)
colorbar
end