% Erstellt die Statistiken fr das Fahrermodell
% aus den Messdaten der Dauermessungen.


% clear all


warning off MATLAB:divideByZero

[Pfad]=uigetdir();
Datensatzname = dir([Pfad '\' '*.mat']);


%%%%%%%%%%%% Statistiken initialisieren:


%%% Allgemeine Fahrzeugdaten
Gaenge = 6+1;                                 % Anzahl der Gnge des Fahrzeugs plus Leerlauf

% Maximale Drehzahl des zu simulierenden Fahrzeugs          
% ANPASSUNG bei neuen Simulationen erforderlich !!!
% n_max_sim=4600;
n_max_sim=6500;

% Steigungsklassen (in Ehra werden im Innenkurs Steigungshgel mit knapp 30 Steigung befahren)
% Steigungs klasse 1: Steigungen unter + 10 % Steigung
% Steigungsklasse 2: Steigungen grer als + 10 % Steigung
% Steigungsklasse 3: Fahrerhandlungen aus Klasse 1 und 2 kombinieren
p_class=3;


%%% OGP
v_max = 250;                                                            % Maximale Geschwindigkeit in km/h
delta_class_v = 5;                                                      % Klassenbreite der Geschwindigkeit in km/h, fr OG und andere Statistiken
Anz_Klassen_v = v_max / delta_class_v;                                  % Klassenanzahl Geschwindigkeit
Max_dt  = 600;                                                          % Maximale Haltedauer des OGP in s
delta_class_dt  = 1;                                                    % Klassenbreite der Haltedauer  in s
Anz_Klassen_dt = ceil(Max_dt / delta_class_dt);                         % Klassenanzahl Haltedauer

RFM_v = zeros(Anz_Klassen_v,Anz_Klassen_v);                             % Initialisierung der OGP-Statistik:        Startklasse, Zielklasse 
v_dt = zeros(Anz_Klassen_dt,Anz_Klassen_v,Anz_Klassen_v);               % Initialisierung der Haltedauer-Statistik: Zeitklasse, Startklasse, Zielklasse
 


%%% Beschleunigen
delta_class_dkw = 10;                                                   % Klassenbreite der Drosselklappenendstellung (Gaspedalendstellung)
Anz_Klassen_dkw = ceil(100 / delta_class_dkw);                          % Klassenanzahl der Drosselklappenendstellung (bis 100%)
Anz_Klassen_dkw_Gradient = ceil(320 / (2 * delta_class_dkw));           % Klassenzahl der Gaspedalgradienten, Max-Wert 300 %/s aus den Messwerten ermittelt, Klassenbreite ist die doppelte dkw-Klassenbreite
GPE = zeros(Anz_Klassen_v,Gaenge,Anz_Klassen_dkw,p_class);              % Initialisierung der Gaspedalendstellungs-Statistik: Ziel-OG, Gang, Klasse der Gaspedalendstellung 
GPG = zeros(Anz_Klassen_dkw,Gaenge,Anz_Klassen_dkw_Gradient,p_class);   % Initialisierung der Gaspedalgradienten-Statistik: Klasse der Gaspedalendstellung, Gang, Klasse des Gaspedalgradienten
SWB = zeros(Anz_Klassen_v,Gaenge,2,p_class);                            % Initialisierung der Schaltwahrscheinlichkeit fr das Beschleunigen: Ziel-OG, Startgang, Anzahl der Manver, Anzahl der Manver mit Schaltung



%%% Verzoegern
                                                                        % keine Gaspedal-Endstellungs-Statistik, da beim verzgern die Endstellung 0% angenommen wird (Messungen haben das besttigt)= No hay ninguna estadstica acelerador-posicin final ya que se supone el retraso de la posicin final del 0% (confirmado con mediciones) 
GPG_V = zeros(Anz_Klassen_dkw,Gaenge,Anz_Klassen_dkw_Gradient,p_class); % Initialisierung der Gaspedalgradienten-Statistik: Klasse der Gaspedalendstellung (wird hier trotzdem bercksichtigt, um Erweiterung des Modells zu ermglichen), Gang, Klasse des Gaspedalgradienten = Inicializacin de la estadstica del gradiente del acelerador: posicin del acelerador (se tiene en cuenta de todas formas para permitir la extensin del modelo), marcha, clase de gradiente del pedal
SWV   = zeros(Anz_Klassen_v,Gaenge,2,p_class);                          % Initialisierung der Schaltwahrscheinlichkeit fr das Verzgern: Ziel-OG, Startgang, Anzahl der Manver, Anzahl der Manver mit Schaltung = Iniciacin de la probabilidad de cambio por retraso: OG-objetivo, marcha inicial, nmero de maniobras, nmero de maniobras con cambio



%%% Gangwechsel
n_max = 7000;                                                           % Maximalwert der Motordrehzahl
delta_class_n   = 200;                                                  % Klassenbreite der Motordrehzahl
Anz_Klassen_n = ceil(n_max / delta_class_n);                            % Anzahl der Drehzahlklassen

Schaltungen = cell(2);                                                  % Cell-Array, in dem die Zeitverlufe von Gaspedal, Ganghebel und Kupplung whrend der Gangwechsel gespeichert werden

SK_hoch = zeros(Anz_Klassen_dkw,Anz_Klassen_n,Gaenge,2,p_class);        % Initialisierung der Hochschalt-Datenbank: Gaspedal-Klassen, Drehzahl-Klassen, Gnge, Anzahl der Manver (2 als Startma, sonst wird keine 4D-Matrix erzeugt)
SK_runter = zeros(1,Anz_Klassen_n,Gaenge,2,p_class);                    % Initialisierung der Hochschalt-Datenbank: Gaspedal-Klasse (es wird angenommen, dass dkw immer =0, daher nur 1 dkw-Klasse), Drehzahl-Klassen, Gnge, Anzahl der Manver

ID_Schaltung = 1;                                                       % Zhler fr die Identifikationsnummer der Schaltung (es wird bei 1 angefangen, damit die erste Schaltung frei bleibt (falls Fehler whrend der Simulation auftauchen))



%%% Bremsung
bd_max = 12;                                                           % Maximalwert des Bremsenddrucks
bdg_max = 8;                                                          % Maximalwert des Bremsdruckgradienten (aus Messungen)
dt_B_max = 120;                                                         % Maximalwert der Bremsdruckverzgerung (nach 2 min sollte das Fzg. auch ohne Bremsung seine OG erreicht haben)
delta_class_BDE  = 0.5;                                                   % Klassenbreite des Bremsdrucks
delta_class_BDG = 0.2;                                                   % Klassenbreite des Bremsdruckgradienten
delta_class_dt_B = 0.5;                                                   % Klassenbreite der Bremsdruckverzgerung
% delta_class_dt_B = 2;
Anz_Klassen_bd = ceil(bd_max / delta_class_BDE);                        % Klassenanzahl des Bremsenddrucks 
Anz_Klassen_bd_Gradient = ceil(bdg_max / delta_class_BDG);              % Klassenanzahl des Bremsdruckgradienten
Anz_Klassen_dt_B = ceil(dt_B_max / delta_class_dt_B);                   % Klassenanzahl der Btremsdruckverzgerung

BDE = zeros(Anz_Klassen_v,Anz_Klassen_bd,p_class);                      % Initialisierung der Bremsenddruck-Statistik: OG-Sprung, Klasse des Bremsenddrucks
BDG = zeros(Anz_Klassen_bd,Anz_Klassen_bd_Gradient,p_class);            % Initialisierung der Bremsdruckgradienten-Statistik: Klasse des Bremsenddrucks, Klasse des Bremsenddrucks
BDV = zeros(Anz_Klassen_dt_B,Anz_Klassen_dt_B,p_class);                 % Initialisierung der Bremsverzgerungs-Statistik: Klasse der OG-Haltedauer, Klasse der Bremsverzgerung
BW = zeros(Anz_Klassen_v,2,p_class);                                    % Initialisierung der Bremswahrscheinlichkeit: OG-Sprung, Anzahl der Manver, Anzahl der Manver mit Bremsung




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for j=1:length(Datensatzname)       %%%%%%%%%%% Anfang Auswerteschleife

    
    disp(' ')
    disp(['Datensatz ' int2str(j) ' von ' int2str(length(Datensatzname)) ' wird ausgewertet'])
    
    [t,v,n_mot,Lenkwinkel,DKI,p_BREMS,Kupplung,Gang,ay,steigung] = Signalaufbereitung_6Gang_MT([Pfad '\' Datensatzname(j).name],n_max_sim);       % Auslesen und Aufbereitung der Messdaten



% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Datenaufbereitung
% T           = 0.1;                                % Zeitkonstante fr zentralen 10Hz-Zeitkanal
% t1          = t1_t;                               % zentralen Zeitkanal erzeugen
% v           = v_t;                                % Geschwindigkeitssignal auf 10 Hz bringen, da Statistik-Generierung auf 10 Hz optimiert
% t           = t1_t-t1_t(1);
% V1          = v_t;
% % Gangsignal berechnen
% 

    
% %%%%%%%%%%% OGP erzeugen

[veck,v_dt,RFM_v] = OGP_Erzeugung(t,v,delta_class_v,Anz_Klassen_dt,delta_class_dt,v_dt,RFM_v, DKI, p_BREMS, Gang);         % die Bestehende OGP-Statistik wird mit bergeben, die neuen Werte werden aufaddiert




% %%%%%%%%% Beschleunigungen
% 
% [GPE,GPG] =
% Beschleunigungsmanoever(veck,v,g,Kupplung,dkw,T,delta_class_v,delta_class_dkw,GPE,GPG,steigung); %Beschleunigungsmanoever=Maniobras de aceleracin  % Gaspedalendstellung und Gaspedalgradient
% 
% 
% 
% %%%%%%%%% Verzgerungen
% 
% GPG_V =
% Verzoegerungsmanoever(veck,v,g,Kupplung,dkw,T,delta_class_v,delta_class_dkw,GPG_V,steigung); %Gaspedalgradient
% 
% 
%                                                                             
% %%%%%%%% Gangwechsel
% 
% [SK_hoch,SK_runter,Schaltungen,ID_Schaltung] =
% Gangwechsel(veck,g,Kupplung,dkw,n_mot,delta_class_dkw,delta_class_n,SK_hoch,SK_runter,Schaltungen,ID_Schaltung,steigung); %der bestehende Cell-Array wird mit bergeben, weil die neuen Manver draufaddiert werden
%
% 
% 
% %%%%%%%%%%% Schalt- und Bremswahrscheinlichkeit
% 
% [SWB,SWV] = Schaltwahrscheinlichkeit(veck,v,g,Kupplung,n_mot,dkw,delta_class_v,delta_class_dkw,SWB,SWV,steigung);
% 
% 
% 
% %%%%%%%%%%% Bremsungen
% 
% [BDE,BDG,BW,BDV] = Bremsmanoever(v,veck,Kupplung,bd,T,delta_class_v,delta_class_BDE,delta_class_BDG,delta_class_dt_B,BDE,BDG,BW,BDV,steigung);
% 
% 
% 
% %%%%%%%%%% Lenkmanoever
% 
% [LWE,LWG1,LWG2,LW] = Lenkmanoever(veck,v,Lenkwinkel,ay,T,delta_class_LW,delta_class_v,Anz_Klassen_LW,LWE,LWG1,LWG2,LW,steigung);




end          %%%%%%%%% Ende der Auswerteschleife


hold on
plot(t,v,'b')
plot(t,veck,'r')





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Speichern der Statistiken

% save Statistik_Ehra_TSI_DSG p_class v_dt RFM_v GPE GPG GPG_V SK_hoch SK_runter Schaltungen SWB SWV BDE BDG BW LWE LWG1 LWG2 LW BDV delta_class_v delta_class_dkw delta_class_n delta_class_LW delta_class_BDE delta_class_BDG delta_class_dt delta_class_dt_B T

% for ii=2:length(Schaltungen)
% if Schaltungen{ii,1}(3,1)==0
% t=t+1;
% end
% end
% t