%Matrix_PP_rpm

clc
clear all

Matrix = zeros(25,10,50,50); %The dimension of the matrix: the maximum limit of the rotational velocity in the gearbox, the accelerator pedal position, the initial speed and the final speed
for k = 1500 : 100 : 3900 %The maximum limit of the rotational velocity (rpm) in the gearbox
    for i = 10 : 10 : 100 %The accelerator pedal position
        load(['Sim_' num2str(k) '_' num2str(i) '.mat']); %To charge the file created in the previous step with the file "Tables_APP_rpm" and "car_rpm_"
        v = ans.Data(:,2)*3.6; %To read the data of the speed in km/h
        time = ans.Time; %To read the data of the time
        Matrix(((k/100)-14),i/10,1,1) = 0;
        for ii = 1 : 50 % Startspeed
            start = find(v>=ii*5-5.001); %To find the value of initial speed
            if isempty(start)
                break
            else
                start = start(1); %The initial speed which is saved
                for iii = 2 : 50 %Endspeed
                    ende = find(v>=iii*5-5); %To find the value of end speed
                    if isempty(ende)
                        break
                    else
                        ende = ende(1); %The final speed which is saved
                        Matrix(((k/100)-14),i/10,ii,iii) = ((v(ende)-v(start))/3.6)/(time(ende)-time(start)); %The Matrix where are kept the values of acceleration
                    end
                end
            end
        end
    end
end

M_x = Matrix;

for k = 1: 25 %To eliminate de nan position and to put zero instead nan, to simulink can read it
    for i = 1: 10
        A = squeeze(Matrix(k,i,:,:));
        A(find(isnan(A)==1)) = 0;
        A(find(A==0)) = i-11;
        Matrix(k,i,:,:) = A;
    end
end

vector_accel = [0:0.1:10]; %The vector of acceleration in m/s2

for i = 1:50
    for ii = 1 : 50
        for rpm = 1:25 %The rpm varied in the next mode 1500:100:3900, so we have 25 values
                if i == ii
                    
                else
                Matrix_pp_rpm(rpm, :, i, ii) = interp1 (Matrix(rpm, 1:end, i, ii),[10 : 10 : 100],vector_accel,'cubic'); %The Matrix where are kept the values of accelerator pedal position to an initial speed, a final speed and a determine acceleration, and which is read for the n-D Lookup Table in the file "car_rpm"
            end
        end
    end
end 
